include FindProcess.inc

.data

pExeFile db 'DlgBox.exe',0
capt1    db 'Error',0
capt2    db 'Process info',0
msg1     db 'Process DlgBox.exe could not be found',0
format1  db 'Handle to DlgBox.exe = %X',13,10
         db 'Caption                       = %s',0

.code

start:

    invoke  WinExec,ADDR pExeFile,SW_SHOW
    call    FindProcess
    invoke  ExitProcess,0

FindProcess PROC USES esi

LOCAL pe32:PROCESSENTRY32
LOCAL hProcessSnap:DWORD
LOCAL nVar:DWORD        ; this variable stores the process ID
LOCAL buffer[128]:BYTE  ; and the window handle respectively
LOCAL szTitle[16]:BYTE

MAX_COUNT   equ SIZEOF szTitle

    lea     esi,[pe32]
    invoke  CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,0
    mov     hProcessSnap,eax
    mov     pe32.dwSize,SIZEOF(PROCESSENTRY32)
    invoke  Process32First,eax,esi
@@:
    invoke  lstrcmp,ADDR pExeFile,ADDR PROCESSENTRY32.szExeFile[esi]
    test    eax,eax
    jz      @f
    invoke  Process32Next,hProcessSnap,esi
    test    eax,eax
    jnz     @b
    invoke  CloseHandle,hProcessSnap
    invoke  MessageBox,0,ADDR msg1,ADDR capt1,MB_ICONWARNING
    ret
@@: 
    invoke  CloseHandle,hProcessSnap
    lea     eax,[nVar]
    push    PROCESSENTRY32.th32ProcessID[esi]
    pop     DWORD PTR [eax]
    invoke  EnumWindows,ADDR EnumWndProc,eax
    invoke  GetWindowText,nVar,ADDR szTitle,MAX_COUNT
    invoke  wsprintf,ADDR buffer,ADDR format1,nVar,ADDR szTitle
    invoke  MessageBox,0,ADDR buffer,ADDR capt2,MB_ICONINFORMATION
    invoke  SendMessage,nVar,WM_CLOSE,0,0
    ret

FindProcess ENDP

EnumWndProc PROC hWnd:DWORD,lParam:DWORD

LOCAL pid:DWORD
    
    invoke  GetWindowThreadProcessId,hWnd,ADDR pid

    mov     edx,lParam
    mov     eax,DWORD PTR [edx]
    cmp     eax,pid
    je      @f
    mov     eax,1
    ret
@@:
    push    hWnd
    pop     DWORD PTR [edx]
    xor     eax,eax
    ret

EnumWndProc ENDP

END start


